var pref = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);

function mydump(aMessage) {
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage(aMessage);
}

function linkElement() {

	this.url="";
	this.description="";				// ha lo slash finale
	this.ultDescription="";
	this.refPage="";
}

function imageElement() {

	this.url="";
	this.description="";
	this.refPage="";
}

function rec(child) {
	var risultato = "";
	try {

		if (child.hasChildNodes()) {
		for (var x = 0; x < child.childNodes.length; x++) {
			if (child.childNodes[x].nodeValue && child.childNodes[x].nodeValue != "") risultato = risultato + child.childNodes[x].nodeValue.replace(/(\n|\r)*/gi, "").replace(/(\s){2,}/gi, " ");
			if (child.childNodes[x].nodeType == 1) risultato = risultato + rec(child.childNodes[x]);
			
			if (child.childNodes[x].hasAttributes()) {
				if (child.childNodes[x].title) 
					risultato = risultato + child.childNodes[x].title + " ";
				else if (child.childNodes[x].alt) 
					risultato = risultato + child.childNodes[x].alt + " ";
			}
		}}
		
	} catch(e) {
		mydump("rec(): " + e);
	}
	
	return risultato;
}

function doesntExist (url, urls) {

	for (var i = 0; i<urls.length; i++) {
		if (urls[i].url == url) 
			return false;
	}
	return true;
}

function addLinksToArray (lnks, urls, ref)	{
	if (lnks && lnks.length) {
		for (var i = 0; i < lnks.length; ++i) {
			var link = lnks[i].href.replace(/#([^\/])*$/gi, "");
			if (isLinkOpenable(lnks[i].href) && doesntExist(link, urls)) {
				var count = urls.length;
				urls[count] = new linkElement();
				urls[count].url = link;
				urls[count].refPage = ref;
				
				if (lnks[i].title)
					urls[count].ultDescription = lnks[i].title + " ";
					
				urls[count].description = rec(lnks[i]);
			}
		}
	}
}

function addImagesToArray (lnks, images, ref)	{
	if (lnks && lnks.length) {
		for (var i = 0; i<lnks.length; ++i) {
			if (isLinkOpenable(lnks[i].src) && doesntExist(lnks[i].src, images)) {
				var count = images.length;
				images[count] = new imageElement();
				images[count].url = lnks[i].src;
				images[count].refPage = ref;
				
				if (lnks[i].hasAttributes()) {
					if (lnks[i].title)
						images[count].description = lnks[i].title;
					else if (lnks[i].alt)
						images[count].description = lnks[i].alt;
				}
				
			}
		}
	}
}

function findLinks(turbo) {
try {
	var urls = new Array();
	var images = new Array();
	var win = document.commandDispatcher.focusedWindow.top;
	
	// gets all the tags "<a>" from the page or frames
	if (win.document) {
		addLinksToArray (win.document.getElementsByTagNameNS("http://www.w3.org/1999/xhtml", "a"), urls, win.document.URL);
		addLinksToArray (win.document.getElementsByTagNameNS("http://www.w3.org/1999/xhtml", "area"), urls, win.document.URL);
		addImagesToArray (win.document.getElementsByTagNameNS("http://www.w3.org/1999/xhtml", "img"), images, win.document.URL);
		addLinksToArray (win.document.getElementsByTagNameNS("*", "a"), urls, win.document.URL);
		addLinksToArray (win.document.getElementsByTagNameNS("*", "area"), urls, win.document.URL);
		addImagesToArray (win.document.getElementsByTagNameNS("*", "img"), images, win.document.URL);
	}
	
	if (win.frames && win.frames.length > 0) {
		for (var i = 0; i<win.frames.length; i++) {
			addLinksToArray (win.frames[i].document.getElementsByTagNameNS("*", "a"), urls, win.frames[i].document.URL);
			addLinksToArray (win.frames[i].document.getElementsByTagNameNS("*", "area"), urls, win.frames[i].document.URL);
			addImagesToArray (win.frames[i].document.getElementsByTagNameNS("*", "img"), images, win.frames[i].document.URL);
			addLinksToArray (win.frames[i].document.getElementsByTagNameNS("http://www.w3.org/1999/xhtml", "a"), urls, win.frames[i].document.URL);
			addLinksToArray (win.frames[i].document.getElementsByTagNameNS("http://www.w3.org/1999/xhtml", "area"), urls, win.frames[i].document.URL);
			addImagesToArray (win.frames[i].document.getElementsByTagNameNS("http://www.w3.org/1999/xhtml", "img"), images, win.frames[i].document.URL);
		}
	}

	// turbo: 4 stati:
	// 0: dta normale
	// 1: tdta
	// 2: dta di un singolo link
	// 3: tdta di un singolo link
	// sends valid links to dialog win
	if (urls.length > 0 || images.length > 0)
		window.openDialog("chrome://dta/content/dta/dta.xul","_blank","chrome,centerscreen,resizable=yes, dialog=no", urls, images, turbo?1:0, gBrowser);
	else {
		// localization hack
		alert(document.getElementById("context-dta").attributes.error1.value);
		return -1;
	}
		
} catch(e) {
	mydump("findLinks(): " + e);
}
	return 0;
}

function isLinkOpenable(lnk, h) {
	if ((isLinkType("http:", lnk) || isLinkType("ftp:", lnk)) && lnk)
		return true;
	else {
		return false;
	}
}

function isLinkType (linktype, link) {
	try {
		var protocol = link.substr(0, linktype.length);
		return protocol.toLowerCase() == linktype;
	} catch(e) {
		return false;
	}
}

function Init() {
	try {
			document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",Hide,false);
	} catch (e) {
		mydump("Init(): " + e);
	}
}

function Hide() {
try {
	var menu = getPreference("extensions.dta.context.menu", "1,1,0").split(",");
	var context = getPreference("extensions.dta.context.compactmenu", false);

	document.getElementById("dta-context-menu").hidden = !context;
	document.getElementById("context-dta-pref").hidden = !(parseInt(menu[2]) && !context);
	document.getElementById("submenu-dta-pref").hidden = !(parseInt(menu[2]) && context);
	document.getElementById("dta-separator").hidden = !(parseInt(menu[2]) && context);
	
	var cm = gContextMenu;
	if (cm.onLink) {
		document.getElementById("context-dta").hidden = true;
		document.getElementById("submenu-dta").hidden = true;
		document.getElementById("context-tdta").hidden = true;
		document.getElementById("submenu-tdta").hidden = true;	
			
		document.getElementById("context-dta-savelink").hidden = !(parseInt(menu[0]) && !context);
		document.getElementById("submenu-dta-savelink").hidden = !(parseInt(menu[0]) && context);
		
		document.getElementById("context-dta-savelinkt").hidden = !(parseInt(menu[1]) && !context);
		document.getElementById("submenu-dta-savelinkt").hidden = !(parseInt(menu[1]) && context);
	} else {
		document.getElementById("context-dta-savelink").hidden = true;
		document.getElementById("submenu-dta-savelink").hidden = true;
		document.getElementById("context-dta-savelinkt").hidden = true;
		document.getElementById("submenu-dta-savelinkt").hidden = true;
		
		document.getElementById("context-dta").hidden = !(parseInt(menu[0]) && !context);
		document.getElementById("submenu-dta").hidden = !(parseInt(menu[0]) && context);

		document.getElementById("context-tdta").hidden = !(parseInt(menu[1]) && !context);
		document.getElementById("submenu-tdta").hidden = !(parseInt(menu[1]) && context);
	}
} catch(e) {
	mydump("Hide(): " + e);
}
}

window.addEventListener("load",Init,false);

function saveLink(turbo, link, referrer) {
try {
	if (!link) {
		var win = document.commandDispatcher.focusedWindow.top;
		
		// salgo su fino a trovare un link
		var cur = gContextMenu.target;
		while (cur.tagName.toLowerCase() != "a")
			cur = cur.parentNode;
		
		var url = new linkElement();
		url.url = cur.href;
		url.description = rec(cur);
		url.refPage = document.commandDispatcher.focusedWindow.document.URL;
		
		if (isLinkOpenable(url.url))
			window.openDialog("chrome://dta/content/dta/dta.xul","_blank","chrome,centerscreen,resizable=yes, dialog=no", url, 0, turbo?3:2, window.gBrowser);
		else
			alert(document.getElementById("context-dta").attributes.error2.value);
	} else {
		if (isLinkOpenable(link)) {
		
			var url = new linkElement();
			url.url = link;
			url.description = "";
		
			try {
				if (window.gBrowser) {
					url.refPage = win.document.URL;
					window.openDialog("chrome://dta/content/dta/dta.xul","_blank","chrome,centerscreen,resizable=yes, dialog=no", url, 0, turbo?3:2, window.gBrowser);
				} else {
					url.refPage = referrer;
					window.openDialog("chrome://dta/content/dta/dta.xul","_blank","chrome,centerscreen,resizable=yes, dialog=no", url, 0, turbo?3:2, false);
				}
			} catch(e) {
				url.refPage = referrer;
				window.openDialog("chrome://dta/content/dta/dta.xul","_blank","chrome,centerscreen,resizable=yes, dialog=no", url, 0, turbo?3:2, false);
			}
		} else
			alert(document.getElementById("context-dta").attributes.error2.value);
	}
} catch(e) {
	mydump("saveLink(): " + e);
}
}

function openManager() {
try {
	var trovato = false;
	var mediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var enumerator, url, ttemp;
	var tabs = getPreference("extensions.dta.windows.usetabs", false);
	
	if (!tabs) {
		enumerator = mediator.getEnumerator(null);
		
		while (enumerator.hasMoreElements()) {
			var win = enumerator.getNext();
			if (win.location == "chrome://dta/content/dta/down.xul") {
				trovato = true;
				break;
			}
		}
		
		if (!trovato) {
			window.openDialog("chrome://dta/content/dta/down.xul", "", "chrome, centerscreen, resizable=yes, dialog=no");
		}
		
	} else {

		for (var i = 0; i< gBrowser.browsers.length; i++) {
			try {
				if (gBrowser.browsers[i].currentURI.scheme + "://" + gBrowser.browsers[i].currentURI.host + gBrowser.browsers[i].currentURI.path == "chrome://dta/content/dta/down.xul") {
					trovato = true;
					break;
				}
			} catch(e) {}
		}
		
		if (!trovato) {
			var newtab = gBrowser.addTab("chrome://dta/content/dta/down.xul");
			var tmp = gBrowser.getBrowserForTab(newtab);
			tmp.addProgressListener(new tabReady(tmp, newtab), Components.interfaces.nsIWebProgress.NOTIFY_ALL);
		}
	}

} catch(e) {
	mydump("openManager(): " + e);
}
}

function tabReady(browser, newtab) {
	this.browser = browser;
	this.tab = newtab;
	this.done = false;
}

tabReady.prototype.QueryInterface = function(aIID) {
   if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
       aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
       aIID.equals(Components.interfaces.nsISupports))
     return this;
   throw Components.results.NS_NOINTERFACE;
}

tabReady.prototype.onStateChange = function(aProgress, aRequest, aFlag, aStatus) {
   if((aFlag & Components.interfaces.nsIWebProgressListener.STATE_IS_WINDOW) && !this.done)
   {
     this.browser.contentWindow.passOpener(gBrowser, this.tab);
     this.done = true;
   }
   return 0;
}

function getPreference(stringa, predefinito) {
	try {
		if (typeof(arguments[1]) == "boolean")
			var scelta = pref.getBoolPref(arguments[0]);
		else if (typeof(arguments[1]) == "string")
			var scelta = pref.getCharPref(arguments[0]);
		else
			var scelta = pref.getIntPref(arguments[0]);
		return scelta;
	} catch (e) {
		mydump("getPreference() [" +  stringa + "] : preference not found. Using default.");
		if (arguments.length == 3 && arguments[2]) {
			if (typeof(arguments[1]) == "boolean")
				var scelta = pref.setBoolPref(arguments[0], arguments[1]);
			else if (typeof(arguments[1]) == "string")
				var scelta = pref.setCharPref(arguments[0], arguments[1]);
			else
				var scelta = pref.setIntPref(arguments[0], arguments[1]);
		}
		return predefinito;
	}
}

var dragObserverTdTa = {
	getSupportedFlavours: function () {
		var flavours = new FlavourSet ();
		flavours.appendFlavour("text/x-moz-url");
		return flavours;
	},
	onDragOver: function(evt,flavour,session) {},
	onDrop: function (evt,dropdata,session) {
		if (dropdata != "") {
			var url = transferUtils.retrieveURLFromData(dropdata.data, dropdata.flavour.contentType);
			
			saveLink(true, url);
		}
	}
};

var dragObserverdTa = {
	getSupportedFlavours: function () {
		var flavours = new FlavourSet ();
		flavours.appendFlavour("text/x-moz-url");
		return flavours;
	},
	onDragOver: function(evt,flavour,session) {},
	onDrop: function (evt,dropdata,session) {
		if (dropdata != "") {
			var url = transferUtils.retrieveURLFromData(dropdata.data, dropdata.flavour.contentType);
			saveLink(false, url);
		}
	}
};
